﻿// check buffer size

  var
    FEvents: array [0..63] of THandle;

  procedure THTTransmitterWorker.AddEvent(event: THandle; cardNumber: integer;
    eventType: THTEventType);
  begin
    if event = INVALID_HANDLE_VALUE then
      Exit;
    if FNumEvents > High(FEvents) then
      raise Exception.Create('[%s] Too many events!');
    FEvents[FNumEvents] := event;
  end;

// check buffer size

  Assert(SizeOf(hlStatus.dsBoardAttributes) = SizeOf(llStatus.BrdAttrib));
  Move(attrib, hlStatus.dsBoardAttributes, SizeOf(hlStatus.dsBoardAttributes));

// not checking result

	mayContinue := CreateEvent(nil, false, false, nil);
  iconnect := InternetOpen(nil, INTERNET_OPEN_TYPE_PROXY, nil, nil, INTERNET_FLAG_ASYNC);
  callBack := InternetSetStatusCallback(iconnect, @CallbackFunction);

// not checking result

	BufLen := Sizeof(IP_ADAPTER_INFO);
  GetAdaptersInfo(nil, BufLen);

// design by contract in Oxygene

  method Foo.Inc(aIncBy: Int32);
  require
    aIncBy > 0;
  begin
    fValue := fValue + aIncBy;
  ensure
    fValue > 0;
    fValue - aIncBy = old fValue;
  end;

// preconditions

  procedure TGpBookmark.JumpTo;
  begin
   Assert(not IsEmpty);
   gbDataSet_ref.GotoBookmark(gbBookmark);
  end;

  procedure TDecayTimer.SetSteps(const steps: array of int64);
  begin
    Assert(Length(steps) > 0);
    SetLength(FSteps, Length(steps));
    Assert(SizeOf(steps[0]) = SizeOf(FSteps[0]));
    Move(steps[0], FSteps[0], Length(steps) * SizeOf(steps[0]));
    Reset;
  end;

// postconditions

  procedure InitializeGlobals;
  begin
    InitializeCriticalSection(GDSiWndHandlerCritSect);
    GTerminateBackgroundTasks := CreateEvent(nil, false, false, nil);
    GDSiWndHandlerCount := 0;
    GTimeGetTimeBase := 0;
    GLastTimeGetTime := 0;
    if not QueryPerformanceFrequency(GPerformanceFrequency) then
      GPerformanceFrequency := 0;
    GCF_HTML := RegisterClipboardFormat('HTML Format');
    DynaLoadAPIs;
    timeBeginPeriod(1);
    Assert(Length(DSiCPUIDs) = 64);
  end;

// use descriptive errors!

  Assert(not((cooCanRepair in options) and (createHeader = '')),
    'TCSVDB.Open: cooCanRepair is set, createHeader is not');

  Assert([cooCanRepair,cooOpenReadonly]*options <> [cooCanRepair,cooOpenReadonly],
    'TCSVDB.Open: cooCanRepair and cooOpenReadonly cannot be set at the same time');

  if cooAllowDifferentStructure in options then
    Assert(cooOpenReadonly in options,
      'TCSVDB.Open: when cooAllowDifferentStructure is set, cooOpenReadonly must be too');

// check the conditions that are "100%" true

  procedure TGpDSWriteThread.ReportBufferWritten(buffer: pointer;
    numBytesWritten: cardinal);
  begin
    Assert(SizeOf(pointer) = SizeOf(integer));
    wtThreadQWriter.PostMessage(INFINITE, MSG_BUFFER_WRITTEN,
      numBytesWritten, integer(buffer));
  end;

// unsafe case, what if new enumeration value is added?

  type
    TGpDVBTeletextDeviceType =
      (tdtDataBridge, tdtSubtitleGenerator, tdtTeletextGenerator);

  // in a unit far far away ...

  var
    device: TGpDVBTeletextDeviceType;

  case device of
    tdtDataBridge,
    tdtSubtitleGenerator: FWorkers[device].ThreadLimit := 10;
    tdtTeletextGenerator: FWorkers[device].ThreadLimit :=  1;
  end;

// better

  case device of
    tdtDataBridge,
    tdtSubtitleGenerator: FWorkers[device].ThreadLimit := 10;
    tdtPCTV:              FWorkers[device].ThreadLimit :=  1;
    else raise Exception.Create('TGpDVBTeletextReceiver.Create: Unknown device');
  end;

// unsafe 'else if' chain, what if new message ID is added?

  procedure THTTransmitterWorker.ProcessMessages;
  var
    msg: TOmniMessage;
  begin
    while FTask.Comm.Receive(msg) do begin
      if msg.MsgID = MSG_REGISTER_HT then
        MsgRegisterHT(msg)
      else if msg.MsgID = MSG_SEND then
        MsgSend(msg)
      else
        Log('[%s] Invalid message received: %d', [FTask.Name, msg.MsgID], svError);
    end;
  end;

  procedure THTTransmitterWorker.ProcessMessages;
  var
    msg: TOmniMessage;
  begin
    while FTask.Comm.Receive(msg) do begin
      if msg.MsgID = MSG_REGISTER_HT then
        MsgRegisterHT(msg)
      else if msg.MsgID = MSG_SEND then
        MsgSend(msg)
      else
        Log('[%s] Invalid message received: %d', [FTask.Name, msg.MsgID], svError);
    end;
  end;

// "It aint't that bad!"

  procedure TTeletextGenerator.GetPreviousPage(client: TSTTNetClient; var pageName:
    TPageName);
  begin
    pageName.pg := client.data.lt.lastgetpg;
    pageName.sb := client.data.lt.lastgetspg;
    if pageName.pg > LowestReadPgno(client) then
    begin
      dec (pageName.pg);
      while ((pageName.pg > HighestReadPgno(client))
        or (DSubp (pageName) = 0)) and (pageName.pg > LowestReadPgno(client)) do dec (pageName.pg);
      if (pageName.pg < LowestReadPgno(client)) or (DSubp (pageName) = 0) then client.ErrorCode := 24
      else
      begin
        pageName.sb:=1;
        FState.lchr:=7;
      end;
    end
    else client.ErrorCode:=24;
  end;

  XXXXXXXXX XXXXXXXXXXXXXXXXXX.XXXXXXXXXXXXXXX(XXXXXX: XXXXXXXXXXXXX; XXX XXXXXXXX:
    XXXXXXXXX);
  XXXXX
    XXXXXXXX.XX := XXXXXX.XXXX.XX.XXXXXXXXX;
    XXXXXXXX.XX := XXXXXX.XXXX.XX.XXXXXXXXXX;
    XX XXXXXXXX.XX > XXXXXXXXXXXXXX(XXXXXX) XXXX
    XXXXX
      XXX (XXXXXXXX.XX);
      XXXXX ((XXXXXXXX.XX > XXXXXXXXXXXXXXX(XXXXXX))
        XX (XXXXX (XXXXXXXX) = X)) XXX (XXXXXXXX.XX > XXXXXXXXXXXXXX(XXXXXX)) XX XXX (XXXXXXXX.XX);
      XX (XXXXXXXX.XX < XXXXXXXXXXXXXX(XXXXXX)) XX (XXXXX (XXXXXXXX) = X) XXXX XXXXXX.XXXXXXXXX := XX
      XXXX
      XXXXX
        XXXXXXXX.XX:=X;
        XXXXXX.XXXX:=X;
      XXX;
    XXX
    XXXX XXXXXX.XXXXXXXXX:=XX;
  XXX;

  procedure TTeletextGenerator.GetPreviousPage(client: TSTTNetClient;
    var pageName: TPageName);
  begin
    pageName.pg := client.data.lt.lastgetpg;
    pageName.sb := client.data.lt.lastgetspg;
    if pageName.pg <= LowestReadPgno(client) then
      client.ErrorCode := ERROR_BAD_PAGE_NUMBER
    else
    begin
      Dec(pageName.pg);
      while ((pageName.pg > HighestReadPgno(client)) or (DSubp(pageName) = 0))
            and (pageName.pg > LowestReadPgno(client))
      do
        Dec(pageName.pg);
      if (pageName.pg < LowestReadPgno(client)) or (DSubp(pageName) = 0) then
        client.ErrorCode := ERROR_BAD_PAGE_NUMBER
      else begin
        pageName.sb := SUBPAGE_FIRST;
        FState.lchr := TTX_COLOR_WHITE;
      end;
    end;
  end;

  XXXXXXXXX XXXXXXXXXXXXXXXXXX.XXXXXXXXXXXXXXX(XXXXXX: XXXXXXXXXXXXX;
    XXX XXXXXXXX: XXXXXXXXX);
  XXXXX
    XXXXXXXX.XX := XXXXXX.XXXX.XX.XXXXXXXXX;
    XXXXXXXX.XX := XXXXXX.XXXX.XX.XXXXXXXXXX;
    XX XXXXXXXX.XX <= XXXXXXXXXXXXXX(XXXXXX) XXXX
      XXXXXX.XXXXXXXXX := XXXXX_XXX_XXXX_XXXXXX
    XXXX
    XXXXX
      XXX(XXXXXXXX.XX);
      XXXXX ((XXXXXXXX.XX > XXXXXXXXXXXXXXX(XXXXXX)) XX (XXXXX(XXXXXXXX) = X))
            XXX (XXXXXXXX.XX > XXXXXXXXXXXXXX(XXXXXX))
      XX
        XXX(XXXXXXXX.XX);
      XX (XXXXXXXX.XX < XXXXXXXXXXXXXX(XXXXXX)) XX (XXXXX(XXXXXXXX) = X) XXXX
        XXXXXX.XXXXXXXXX := XXXXX_XXX_XXXX_XXXXXX
      XXXX XXXXX
        XXXXXXXX.XX := XXXXXXX_XXXXX;
        XXXXXX.XXXX := XXX_XXXXX_XXXXX;
      XXX;
    XXX;
  XXX;

// "Don't be a smartass"

FizzBuzzNormal.dpr
FizzBuzzAnon.dpr

// "And who will support that?

  constructor TInterfacedMonitor.Create(const instance: TObject);
  begin
    inherited Create;
    fInstance := instance;
    Enter;
  end;

  destructor TInterfacedMonitor.Destroy;
  begin
    Leave;
    inherited;
  end;

  procedure TInterfacedMonitor.Enter;
  begin
    MonitorEnter(fInstance);
  end;

  procedure TInterfacedMonitor.Leave;
  begin
    MonitorExit(fInstance);
  end;

  function Lock(const instance: TObject): ILock;
  begin
    Result := TInterfacedMonitor.Create(instance);
  end;

// or

  function MemAddRef(inst: PMonitorRec): Integer; stdcall;
  begin
    Result := AtomicIncrement(inst.RefCount);
  end;

  function MemRelease(inst: PMonitorRec): Integer; stdcall;
  begin
    Result := AtomicDecrement(inst.RefCount);
    if Result = 0 then
    begin
      System.MonitorExit(inst.Instance);
      FreeMem(inst);
    end;
  end;

  const
    Monitor_Vtable: array[0..4] of Pointer =
    (
      @NopQueryInterface,
      @MemAddref,
      @MemRelease,
      @MonitorEnter,
      @MonitorLeave
    );

  function Lock(const instance: TObject): ILock;
  begin
    System.MonitorEnter(instance);
    GetMem(Pointer(Result), SizeOf(TMonitorRec));
    PMonitorRec(Result).Vtable := @Monitor_Vtable;
    PMonitorRec(Result).RefCount := 1;
    PMonitorRec(Result).Instance := instance;
  end;

// "But look, it is sooooo beautiful!"

  type
    TPageMapping  = TPair<integer,integer>;

  function TFDSStgTeletextOutput.GetPageRenumber(const index: integer): TPageRenumber;
  begin
    // Maps stored property in form 'num=num,num=num,...,num=num'
    // into TArray<TPair<integer,integer>>.
    // Numbers are hexadecimal without any preceeding prefix (like '$').

    Result := TArrayEx<string>.Create(GetXMLProp(index).Split([',']))
      .Map<TPageMapping>(
        function (const s: string; var pair: TPageMapping): boolean
        begin
          Result := TArrayEx<string>.Create(s.Split(['=']))
            .Map<integer>(
              function (const s: string; var val: integer): boolean
              begin
                Result := TryStrToInt('$' + s, val);
              end)
            .MakePair(pair);
        end)
      .ToArray;
  end;

// "My <insert deity>, does this ever end?"

// Code removed for sanity reasons.

// Nice code (by my standards)

  function EvaluateAST(ast: TTerm): integer;
  var
    add1  : TAddition;
    const1: TConstant;
  begin
    if not assigned(ast) then
      raise Exception.Create('Result is undefined!');

    if IsConstant(ast, const1) then
      Result := const1.Value
    else if IsAddition(ast, add1) then
      Result := EvaluateAST(add1.Term1) + EvaluateAST(add1.Term2)
    else
      raise Exception.Create('Internal error. Unknown AST element: ' + ast.ClassName);
  end;

  XXXXXXXX XXXXXXXXXXX(XXX: XXXXX): XXXXXXX;
  XXX
    XXXX  : XXXXXXXXX;
    XXXXXX: XXXXXXXXX;
  XXXXX
    XX XXX XXXXXXXX(XXX) XXXX
      XXXXX XXXXXXXXX.XXXXXX('XXXXXX XX XXXXXXXXX!');

    XX XXXXXXXXXX(XXX, XXXXXX) XXXX
      XXXXXX := XXXXXX.XXXXX
    XXXX XX XXXXXXXXXX(XXX, XXXX) XXXX
      XXXXXX := XXXXXXXXXXX(XXXX.XXXXX) + XXXXXXXXXXX(XXXX.XXXXX)
    XXXX
      XXXXX XXXXXXXXX.XXXXXX('XXXXXXXX XXXXX. XXXXXXX XXX XXXXXXX: ' + XXX.XXXXXXXXX);
  XXX;

// use intermediate variables

  for iTeletext := 0 to cfgSettings.Teletext.Count - 1 do begin
    if cfgSettings.Teletext[iTeletext].Input.DeviceType <> tdtDataBridge or
      continue;
    Activate(cfgSettings.Teletext[iTeletext].Input.CardNumber);
    for iOutput := 0 to cfgSettings.Teletext[iTeletext].Outputs.Count - 1 do begin
      if cfgSettings.Teletext[iTeletext].Outputs[iOutput].OutputType <> otSDI then
        continue;
      Activate(cfgSettings.Teletext[iTeletext].Outputs[iOutput].SDI.CardNumber);
    end;
  end;

  for iTeletext := 0 to cfgSettings.Teletext.Count - 1 do begin
    teletext := cfgSettings.Teletext[iTeletext];
    if teletext.Input.DeviceType <> tdtDataBridge then
      continue;
    Activate(teletext.Input.CardNumber);
    for iOutput := 0 to teletext.Outputs.Count - 1 do begin
      output := teletext.Outputs[iOutput];
      if output.OutputType <> otSDI then
        continue;
      Activate(output.SDI.CardNumber);
    end;
  end;

  // Use enumerators, when available (or implement them if you own the code)

  for teletext in cfgSettings.Teletext do begin
    if teletext.Input.DeviceType <> tdtDataBridge then
      continue;
    Activate(teletext.Input.CardNumber);
    for output in teletext.Outputs do begin
      if output.OutputType <> otSDI then
        continue;
      Activate(output.SDI.CardNumber);
    end;
  end;

// Simple cases first

  // no

  while i >= 0 do begin
    thisSteps := numSteps div (i + 1);
    if thisSteps > 0 then begin
      FPartition[i].LowBound := first;
      FPartition[i].HighBound := first + (thisSteps - 1) * FStep;
      first := FPartition[i].HighBound + FStep;
      numSteps := numSteps - thisSteps;
    end
    else
      Dec(numTasks)
  end;

  // yes

  while i >= 0 do begin
    thisSteps := numSteps div (i + 1);
    if thisSteps = 0 then
      Dec(numTasks)
    else begin
      FPartition[i].LowBound := first;
      FPartition[i].HighBound := first + (thisSteps - 1) * FStep;
      first := FPartition[i].HighBound + FStep;
      numSteps := numSteps - thisSteps;
    end;
  end;

  procedure TGpRealDSFileInterface.ThreadQMain(var messg: TMessage);
  var
    flags  : TGpMQMessageFlags;
    lParam : NativeInt;
    msg    : cardinal;
    msgData: AnsiString;
    qStatus: TGpMQGetStatus;
    wParam : NativeUInt;
  begin
    if messg.Msg <> WM_USER then
      Result := DefWindowProc(fiThreadQWindow, messg.Msg, messg.wParam, messg.lParam)
    else begin
      repeat
        qStatus := fiThreadQReader.GetMessage(INFINITE, flags, msg,
                                              wParam, lParam, msgData);
        if qStatus = mqgOK then begin
          if msg = MSG_PCR_WRAP then
            DoPCRWrap
          else if msg = MSG_PCR_JUMP then
            DoPCRJump
          else if msg = MSG_PID_LIST then
            DoPIDList(string(msgData))
          else
            ...
        end;
      until qStatus = mqgQueueEmpty;
    end;
  end;

// visually match allocate/release

  procedure TfrmDiskRouter.StartRecording;
  var
    pidList: TGpIntegerList;
  begin
    HideVisualizer;
    pidList := TGpIntegerList.Create;
    try
      pidList.Text := StringReplace(inpPIDs.Text, ' ', #13#10, [rfReplaceAll]);
      StartRecordingPIDs(pidList);
    finally FreeAndNil(pidList); end;
  end;

  procedure TGpDriverTable.Release(driverSig: cardinal);
  var
    driverInfo: TGpDriverInfo;
  begin
    FTableLock.Acquire;
    try
      driverInfo := TGpDriverInfo(FTable.FetchObject(integer(driverSig)));
      if not assigned(driverInfo) then
        raise Exception.Create('TGpDriverTable.Release: Driver not allocated');
      if driverInfo.Release = 0 then begin
        driverInfo.Driver.Close;
        FTable.Remove(integer(driverSig));
      end;
    finally FTableLock.Release; end;
  end;

// With? Just say no!

 	with LMargins, GlassFrame do
   begin
     if Enabled then
     begin
       if not SheetOfGlass then
       begin
         cxLeftWidth := Left;
         cxRightWidth := Right;

// and

 	with component do
    Caption := ‘test’;

// Treat numbers with suspicion

  SetLength(dmPacketSizes, 5);
  if not (spcFast in sourceProvider.GetCapabilities) then
    maxDataCount := sourceProvider.GetPackageSizeLimit
  else if dmoPreserveOrder in dmOptions then
    maxDataCount := CMaxPreserveOrderPackageSize
  else
    maxDataCount := High(integer);
  for iGen := Low(dmPacketSizes) to High(dmPacketSizes) do begin
    dmPacketSizes[iGen] := Round(Exp(2 * iGen * Ln(3))); // 3^(2*iGen)
    if dmPacketSizes[iGen] > maxDataCount then begin
      SetLength(dmPacketSizes, iGen);
      break; //for iGen
    end;
  end;

// better ...

  for iGen := Low(dmPacketSizes) to High(dmPacketSizes) do begin

// Exceptions

  // do

  function SafeCreateFileStream(const fileName: string; mode: word;
    var fileStream: TFileStream; var errorMessage: string): boolean; overload;
  begin
    Result := false;
    errorMessage := '';
    try
      fileStream := TFileStream.Create(fileName, mode);
      Result := true;
    except
      on E: EFCreateError do
        errorMessage := E.Message;
      on E: EFOpenError do
        errorMessage := E.Message;
    end;
  end;

  // don't do that

  function SafeCreateFileStream(const fileName: string; mode: word;
    var fileStream: TFileStream; var errorMessage: string): boolean; overload;
  begin
    Result := false;
    errorMessage := '';
    try
      fileStream := TFileStream.Create(fileName, mode);
      Result := true;
    except
      on E: Exception do
        errorMessage := E.Message;
    end;
  end;

  // and don't you dare do do that!

  function SafeCreateFileStream(const fileName: string; mode: word;
    var fileStream: TFileStream;): boolean; overload;
  begin
    Result := false;
    errorMessage := '';
    try
      fileStream := TFileStream.Create(fileName, mode);
      Result := true;
    except
    end;
  end;

// logging all exceptions except announced (NOT recommended practice)

  with AutoLog.Expect(ERestRequestException) do try
    try
      actionRes := method.Invoke(Self, arguments);
    except
      on E: ERestRequestException do
        overrideResult := TRestResponse.Create(E.RestResponse);
    end;
  finally
    Release;
  end;



